.LP
.po 1.25i
.nr PO 1.25i
.nr PS 12
.nr VS 14
.ft HB
.ps 16
.vs 18
.ce
Advanced Announcement and Call For Papers
.sp .6i
.ps 20
.ce
Journal of Internetworking
.sp .2i
.ps 14
.ce
Research and Experience
.sp .5i
.ft R
.ce
\fHAims and Scope\fP
.PP
Designing and implementing communication protocols that enable heterogeneous
computer systems to interoperate is extremely difficult.  The demand for
such protocols has risen sharply as users have begun to connect diverse
systems together.  For example, the federally-supported Internet
in the US has grown from a few dozen research institutions into a worldwide
network connecting tens of thousands of computers and hundreds of thousands
of users.  At the same time, the international community is developing
standards for open system interconnection (OSI).
.PP
Much of the recent work in internet protocols has been of an experimental
or practical nature using the Internet as an experimental facility.  As
new international standards arise, there will be more implementation and
experimental efforts.  The results of this work have been reported primarily
in technical reports, RFCs, and various conference proceedings.  No journal
concentrates on interoperability and internet protocols research.
.PP
INTERNETWORKING will seek to provide a focus for original results of
research in interoperability; a mechanism for quality control and
verification through the refereeing process; and opportunities for comment
and debate in a public and easily accessible forum.
.PP
The journal will encourage papers on topics ranging from architectural models
to details of implementations and performance measurements.  The emphasis
will be primarily on those papers reporting practical experience gained in
designing, implementing or using internet protocols.  However, papers of
a more mathematical or theoretical nature that might contribute to the
development of, or better understanding of, methods of design, construction
and use of internetworking protocols will also be welcomed.  Shorter,
unrefereed notes and letters may be published if they relate to  current
research topics or previously published articles.
.PP
Articles may range in length from a short note (perhaps half a page) to the
length required to document a design in detail (perhaps forty pages or more).
The goal is to provide timely dissemination of results while maintaining
a thorough review process.
.PP
INTERNETWORKING will provide a valuable source of reference to all who
design, implement or use internet protocol software, or who want to learn
more about the technology.  Anyone involved in the investigation of
interoperability or the communication protocols that support it should
consider writing about their work for the journal.
.bp 1
.ta 1.5i
.nf
\fH\s+2Editor-in-chief\s0\fP:
.sp .5
	Professor Douglas E. Comer
	Computer Sciences Department
	Purdue University
	West Lafayette, IN 47907
	USA
.sp .4
	Tel: (317) 494-6009
	comer\|@\|purdue.edu
.sp
\fH\s+2Editors:\s0\fP
.sp .5
	Ralph A. Droms
	Computer Science Department
	Bucknell University
	Lewisburg, PA 17837
	USA
.sp .4
	Tel: (703) 620-8990
	rdroms\|@\|nri.reston.va.us
.sp 1.5
	Deborah L. Estrin
	Computer Science Department
	Henry Salvatori Computer Science Center
	University of Southern California
	Los Angeles, CA  90089-0782
	USA
.sp .5
	Tel: (213) 743-7842
	estrin\|@\|oberon.usc.edu
.sp
.PP
A further editor and an international editorial board are currently
being appointed.  Full details will be announced prior to publication
of the first issue.
.sp 1.5
\fH\s+2Publisher:\s0\fP
.sp
.PP
John Wiley & Sons of Chichester New York Brisbane Toronto Singapore
.sp 1.5
\fH\s+2Call For Papers:\s0\fP
.sp
.PP
Papers are solicited for the first two issues with initial submission
deadlines of December 31, 1989 and March 31, 1990.  The first two issues
will be published in 1990.
.sp
.PP
For further details please contact one of the editors.
