.nr PO 1.25i
.po 1.25i
.DS L
.sp 6
.in +4.5i
\*(DY
.in -4.5i
.sp 2
.DE
.LP
Dear Rainer:
.sp 0.5
.LP
I've gotten the reviews back for your paper.  The news is generally
good.  The reviewers were very interested in the idea of applying
the QIE to networking problems; in other words, the basic idea of the
paper is both sound, and interesting.
.sp 0.5
.LP
The reviewers did have some serious concerns about how the material
was presented.  I've talked with them on the phone a bit, because
their comments seemed a bit harsh, to make sure I understood their
concerns.  After some discussion, it appears that, with a little
additional work  (and I really mean ``little'') the paper should
be ready for publication.
.sp 0.5
.LP
The major concerns are:
.LP
\(bu Problems aren't always presented clearly.  (This is usually a matter
of a paragraph or even a sentence in a few places).  One concern
was the description of the QIE itself.  Both reviewers would really like
a one sentence description of the class of algorithm the QIE attempts
to solve.  For example:
.QP
Larson's Queueing Inference Engine uses service completion times to estimate
queue lengths for processes with Poisson arrivals and arbitrary
service disciplines.  Bertsimas and Servi have extended Larson's
work by relaxing the requirement of Poisson arrivals, and by
improving the algorithm for generating queue lengths (from
an \fIO(n\u\s-2\5\s0\d)\fP algorithm, to an \fIO(n\u\s-2\3\s0\d)\fP
algorithm).
.LP
\(bu Another concern was that the paper was unclear about the problem
being attacked.  The key problem (as I see it, and I think they do
too), is to see if QIE ideas can be applied to communication
networks.  Thus, the abstract of the paper (or some paragraph
early in the introduction) could be written something like this:
.QP
Queueing theorists have recently developed an algorithm which makes
it possible to derive the lengths of queues, based on information
about service completions.  The original goal of this work was to
estimate the length of lines of customers waiting for automatic teller
machines.  In this paper, we look at applying this work to the
problem of estimating queue lengths in telecommunications networks.
.LP
\(bu Some minor technical glitches in presentation which lead folks to
question the validity of the paper itself (sigh...).  Two important
ones here.  First, the suggestion that negative queue lengths are
round-off error.  After some discussion, the reviewers and I believe
that the result is more likely that for longer busy periods, the
arrival process looks less Poisson (perhaps due to the effects of
packet trains).  In other words, one or more sources are showing
non-Poisson behavior over a long enough period that it is causing
the algorithm to break down.  (Note, it is perfectly reasonable to
say that's the suspected cause, and quit there.  You don't have
to solve all the issues in this paper).
Second there was some suspicion about using Ethernet data as the test case.  I
think you can largely punt on this.  The goal was to experiment \(em
for some experiments, you got some intriguing results and correlations.
That alone will interest your audience and convince them there's
something to follow up here.  And I think that's the goal;
people will say ``this guy Gawlick has a nifty idea'' and go
play with it.
.LP
\(bu Finally, one reviewer caught some nits in the explanation of the QIE
which you should clean up.
.sp 0.5
.LP
I hope these comments help.  I really think you've got, essentially,
a few hours of careful revision, and you'll have a good solid paper.
If you can do that in the next couple of weeks, I can publish the
paper in the October issue.
If you've got any questions at all, please feel free to call me
(617) 873-2459.
.sp 0.5
.LP
Thanks!
.sp 6
Craig Partridge
.br
BBN, MS 6/5A
.br
10 Moulton St
.br
Cambridge MA 02138
.sp
craig@bbn.com
