.nr PO 1.25i
.po 1.25i
.ds CH
.DS C
\fIThe Simple Book:
An Introduction to Management of TCP/IP-based internets\fP
by
Marshall T. Rose
Prentice Hall, 1990
.sp
reviewed by:
Greg Satz
cisco Systems, Inc.
.DE
.PP
Marshall Rose's latest book, The Simple Book: An Introduction to Management
of TCP/IP-based internets, continues his elucidation of networking
technology. With the rapid growth of computer networks in education,
government and industry, the topic of network management becomes more
compelling. There are now more networking devices in the marketplace than
there have ever been before, and furthermore, the future does not appear to
offer a respite. With this explosion of internetworking products, their
management becomes all the more importunate.
.PP
Network management seems to evoke different opinions from everyone. This is
probably due to its recent emergence as a technology. Marshall's book
offers to light up the subject based on real-world operational experience
and some very sharp insight. Like his last work, The Open Book, he includes
a number of ``soap boxes'' where he offers his unique opinion on matters both
technical and political. There is much room for opinions in this new field
of network management, but Marshall endeavors to guide you down a well-lit
path.
.PP
The book opens with a brief history of network management in the Internet.
Missing is any coverage of the proprietary techniques used to monitor or
manage internetworks before the history section began, but the history of
network management that Marshall does report is quite colorful. He covers
how he got involved in network management and opens the door for a brief
look at some of the issues that happened.
.PP
I was a bit surprised to find an introduction to the OSI; however, it is
one of the better explanations of the basic structure and design of the OSI
and serves to lay the groundwork for later discussions. One of the more
useful topics is the OSI framework for network management. Marshall
explains some of the thinking behind the design of CMIS/CMIP.
.PP
The OSI framework is followed by an introduction to the TCP/IP protocol
suite. Included in this chapter was an explanation of how the TCP/IP
standardization process works. As far as I am aware, this is the first time
this process has appeared in print outside of RFCs or verbal discussions.
The TCP/IP architectural model is discussed with a section devoted to each
of the 4 layers, interface, internet, transport and application. These
sections comprise a very good and complete precis of the TCP/IP protocol
suite. From ARP to TCP the language is clear, concise and accurate. The
section on routing covers subnetting, EGP and even mentioned BGP. The last
part of the chapter covers Ping, Traceroute and network monitoring. This
chapter stands out as one of the better introductions to the TCP/IP
architecture. It alone makes the book worth reading.
.PP
The third chapter starts the real network management discussions and offers
the first hint behind the book's title. Given the number and diverse type
of internetworking products, Marshall defines his fundamental axiom:
.PP
The impact of adding network management to managed nodes must be 
minimal, reflecting a lowest common denominator.
.PP
Thus begins the explanation of why there is the simple in SNMP. ASN.1
basics for SNMP is introduced. Anyone who has implemented ASN.1 from the
ISO specifications will appreciate this section. Details of the Basic
Encoding Rules (BER) are covered later.
.PP
The Internet-standard Network Management Framework is introduced with the
Structure of Management Information (SMI) and Management Information Base
(MIB) documents. The SMI is covered first. Much of what is discussed is not
presented together this cohesively anywhere else. Both MIB I and MIB II are
explained with the differences highlighted. Case diagrams are introduced
and used to help demonstrate how MIB variables relate to each other. This
section will be invaluable to a potential implementor as a few points are
covered that are not mentioned anywhere in the RFCs!
.PP
Chapter 5 discusses the Simple Network Management Protocol. Here is where
Marshall ties together everything covered so far. It also contains the best
definition of ``community'' I have seen. The one nit I have to pick is with
the section on ``Row Addition.'' Marshall explains that a row can be added to
a table by performing a SET operation on all of the columns in that row
with the same instance identifier. What happens if one of the columns in a
row is omitted?
.PP
SNMP can be run over IP/UDP, Ethernet, and both types of the OSI transport
services, connectionless and connection-oriented.
.PP
Interestingly enough, Marshall admits that the hardest part of the network
management problem is writing the applications that use the SMIs, MIBs and
protocols. A brief look at a set of applications is presented along with
some examples on how to use them to solve networking problems.
.PP
Marshall has written a complete SNMP agent for 4BSD Unix (Unix is a
trademark of AT&T) which he provides complete with his ISO Development
Environment (ISODE) package. Ordering information for ISODE can be found in
an appendix. Included is a tool for rapid-prototyping network management
applications. Both are covered in some detail including data structures and
support subroutines to help clarify the design. Also included is a
description of a mechanism for distributing MIB support among multiple Unix
processes. This new protocol is called SNMP Multiplexing (SMUX).
.PP
Marshall offers his vision of the future in the last chapter as one big
soap box. I was a bit surprised by the lack of soap boxes throughout the
text but found he saved them for the final chapter. 
.PP
This one book contains information that will help both beginner and expert.
If you do not know what network management is and want to find out, then
read it. If you do know what network management is but have some questions
or want to write a MIB, then read it. Simply put, read it.
