.nr PO 1.25i
.ds CH
.nr PS 11
.nr VS 13.2
.DS C
Rebuttal, by John D. Spragins, book author, to Victor T. Norman's 
Review of \fITelecommunications:  Protocols and Design\fP written by
John D. Spragins, with Joseph L. Hammond and Krzysztof Pawlikowski
Addison-Wesley, 1991 in ACM \fIComputer Communication Review\fP, 
January 1991
.DE
.PP
This review, by a graduate student in the Computer Science department at 
Purdue, makes extremely critical comments, some of which merit rebuttal.  
This note is intended to correct some false impressions conveyed by the 
review.  I am writing the rebuttal myself because of extremely tight time 
constraints, less than 24 hours between the time my editor and I decided a 
rebuttal in the April issue was needed and the deadline for Craig Partridge 
to receive the material in Sweden.
.PP
The review makes a major point of the fact that the book does not contain 
detailed discussions about addresses and addressing issues, which are 
important topics in networking.  Although some basic ideas of addressing 
are discussed, I decided not to include detailed discussions since I think 
the most interesting recent work on addressing has been done by groups 
working on protocols at higher layers than those covered in the text (such 
as the X.400 protocol - normally considered part of the OSI Application 
Layer).  Detailed coverage of addressing did not seem appropriate for a 
book concentrating on protocols at the equivalent of the lower four layers 
of the OSI architecture, and which was already getting long.
.PP
The review states that the book ``covers many details of protocol 
specifications, but does not introduce a protocol by stating its important 
concepts and goals of the protocol.''  In fact discussions of protocol layers 
are preceded by chapters discussing major problems addressed by the 
layers, e.g. chapters on medium access control and on synchronization 
and error control precede the chapter on the data link layer and a chapter 
on routing and flow control precedes the chapter on the network layer.  
Each chapter on a protocol layer is then introduced by summarizing the 
purpose of that layer, with discussions of actual protocols (rather than the 
artificial examples in some texts) used to illustrate how protocols 
implement the functions described in the preceding chapters.  Discussions 
of individual protocols are terminated with discussions of their strengths 
and weaknesses, and the manner in which later protocols eliminate 
weaknesses of earlier ones is illustrated.  I included such material to 
demonstrate how evolution of protocols is an ongoing process.
.PP
The review states that much of the text is not well written, containing 
sentences that are awkward and require multiple readings, and that 
computer science students will find it difficult to comprehend the detailed 
hardware descriptions.  I am sure some material is difficult to 
comprehend, but think it is legitimate to quote another opinion.  A friend 
passed on the following comment from a person who took a course using 
the text during the Fall of 1990, after spending eight years working in 
telecommunications.  ``The book is very well written.  I appreciate it more 
than other students because I know how complex the issues are he is 
dealing with, and he covers a lot of practical considerations at a simple 
level without sacrificing accuracy (he has footnotes to the degree of 
nitpicking!).''  With respect to detailed hardware descriptions, they appear 
at a limited number of spots, and the Preface indicates they can be omitted 
without serious loss by readers who are not interested in them or do not 
have the background to understand them.
.PP
The review states further that, ``Perhaps the most disconcerting feeling one 
gets when reading this book is the impression that Spragins did not write 
this book from his own, first-hand experiences, but rather from reading 
standards documents and others' explanations of protocols and concepts.  
One sees this in the number of illustrations 'adapted' from other sources.''  
I plead guilty to using the types of sources mentioned for much of the 
material, although parts of the book are based on my experiences when 
working with developers of some protocols treated.  It is difficult to 
visualize any other feasible method of acquiring detailed information about 
the wide variety of protocols in the book as it is doubtful that any single 
person has had detailed implementation experience with all of them.  The 
documents I examined were carefully compared, with emphasis on 
original sources, and I made major efforts to put material in consistent 
form.  This resulted in ``adapting'' numerous illustrations by changing 
their formats to be consistent with the treatment in the book, to make them 
easier to interpret, or (in an unfortunately large number of cases) to correct 
errors.  In many cases the adaptations resulted in such significant changes 
that references to original sources were not required, but I tried to give 
credit to others whenever it was due.  I consider the number of ``adapted'' 
illustrations to be a strength of the book.
.PP
Norman states that an example of setting up an OSI connection-oriented 
service given in the book is erroneous since it implies two packet 
exchanges per layer are needed for a total of 14 packet exchanges.  The 
example is included in the first material introducing the OSI model, and is 
fairly conventional in that the OSI model is often introduced in this 
manner.  In a few circumstances it is possible to use single packet 
exchanges to set up connections at more than one layer, but this is not 
standard.  Recent papers by developers of OSI give treatments similar to 
that in the book.
.PP
The review also states that the organization of the book is poor since some 
topics tend to be repeated in the same manner in which they appear at 
different layers in the OSI architecture.  I plead guilty to discussing such 
topics as flow control or error control at several spots, since such 
functions are necessary at several levels in an overall architecture, often 
serving slightly different functions.  For example, as the book points out, 
the types of errors that must be handled by different layers are different.  
Norman also cites inclusion of the IP layer of the TCP/IP suite in a 
subsection in the section titled ``Routers and Gateways'' of the chapter on 
``Internetworking'' as an example of haphazard organization.   I consider 
this to be the logical place to include this material.  Internetworking was 
included as a separate chapter because of its importance, even though the 
OSI model does not consider it a separate layer.  Standard terminology is 
to call any internetworking relay operating at the network or higher layer 
(such as one implementing the DoD IP protocol, the OSI IP protocol or 
the X.75 protocol) a router or gateway.  This dictated the location of the 
discussion of each of these three important protocols.
.PP
In summary, this review ignores most strong points of the book, while 
focusing on weaknesses which are only partially valid.  I think some of 
the cited weaknesses, such as the ``adapted'' illustrations and book 
organization, are actually strengths.  I confess to failing to achieve one of 
my goals, however.  I had hoped to simplify the complex verbiage used in 
the field enough to treat all protocols discussed with essentially the same 
terminology.  I was only partially successful with this.  Although I think 
my use of terminology is more consistent than that in any competitive 
book, writing a book with fully consistent terminology would have 
required several more years of effort.
.PP
Norman's review completely ignores some of the sections of the book of 
which I am most proud, such as the material on Fundamental Limits in 
Chapter 2, the material on Medium Access Control in Chapter 5 (largely 
written by Joe Hammond), the Synchronization and Error Control 
material in Chapter 6 and the material on Routing and Flow Control in 
Chapter 8.   I think each of these coverages is significantly better than 
coverage of comparable material in any competitive book, but will not 
attempt to review it myself.  Hopefully some other reviewers will discuss 
this material.
