.nr PO 1.2i
.po 1.2i
.nr PS 11
.nr VS 13.2
.DS C
.ft B
Review of
.sp
.ps +1
.ft I
Abstract Syntax Notation One (ASN.1): The Tutorial and Reference
.sp
.ps -1
.ft R
by Douglas Steedman
Technology Appraisals Ltd. ISBN 1-871802-06-7
.sp 2
Reviewed by Craig Partridge, Stockholm, Sweden
.DE
.PP
ASN.1 is the OSI standard for describing and encoding data which is
to be transferred between two systems via a data network.  Independent
of its role in OSI, ASN.1 is widely considered an important data
communications standard and is used in some non-OSI protocols.
This book is a tutorial on ASN.1, written by one of the members of
the standards committees that designed it.
.PP
ASN.1 is actually divided into two parts: a data description language
and a set of encoding rules which are used to transmit the
data described by the language over a network.  The language and
encoding rules are theoretically distinct; in practice they are
almost distinct \- the language clearly reflects the expectation
that an encoding scheme like the one defined for ASN.1 will be
used.
.PP
The book begins with two short introductory chapters which outline
the history of ASN.1 and describe the basic idea of an abstract syntax.
The next three chapters describe the ASN.1 language in detail.
The sixth chapter explains the encoding rules, with many useful
examples.  The final three chapters present ASN.1's role in OSI,
very very briefly discuss implementation issues, and mention
some changes that are being considered in the standards bodies.
The book concludes with a variety of useful appendicies including
syntax diagrams and lists of ASN.1 keywords.
.PP
Overall, the book is impressive.  The examples are clear and usually
well-chosen.  The text is informative.  The author's occasional
explanations of standards debates which led to particular design choices
are quite useful.
.PP
The only serious complaint that can be made about the book is that its
discussion of implementation concerns, and in particular, of the
implementation issues surrounding the encoding rules, is inadequate.
The original work on which the encoding rules are based [1] was an
attempt to define a regular encoding scheme (in which all values are
represented in a consistent form) that minimized the size of the encoding.
As a result,
encoding and decoding ASN.1 is often reported to be more than a factor
of ten more expensive than other encoding schemes and has led some
researchers to propose alternative encoding schemes [2].  The book does
not seriously address this implementation problem.
.LP
[1]
D. Deutsch, R. Resnick, and J. Vittal,
Specification of a Draft Message Format Standard,
Bolt Beranek and Newman Report, No. 4486,
(September, 1980).
.LP
[2]
Christian Huitema and Assem Doghri,
Defining Faster Transfer Syntaxes for the OSI Presentation Protocol,
Computer Communication Review, Vol. 19, No. 5, October 1989
pp. 44-55
