.nr PO 1.25i
.po 1.25i
.nr PS 11
.nr VS 13.2
.DS C
\fIThe Art of Computer Systems Performance Analysis; Techniques for
Experimental Design, Measurement, Simulation and Modelling\fP
.sp
by Raj Jain
.sp 0.5
John Wiley and Sons, 1991, ISBN 0471-50336-3
.sp
Reviewed by Craig Partridge
.DE
.LP
The goal of this large book is to comprehensively survey the field of
computer performance analysis.
.LP
The book starts with an brief overview (3 short chapters) of performance
evaluation, which lists key journals, discusses common errors made in
performance evaluation, and touches on issues of choosing evaluation
techniques and metrics.  The second section of the book (7 chapters) presents
measurement techniques and tools.  There are good discussions of issues
related to choosing workload models characterizing results from workload
measurements, and displaying data collected.  The third section (4 chapters)
is a basic introduction to probability and statistics.  These chapters focus
on basic statistical techniques; probability theory is given only a couple
of pages.
.LP
The fourth and fifth sections are the most interesting, a total of 14
chapters on experimental design, analysis and simulation.  Jain's
skillful applications of these methods to problems in computer
communication have made him widely respected in the field, and
the chapters reflect his close knowledge of the field.
.LP
The final section discusses queueing theory.  This section is probably
the weakest.  Jain, with some good reasons, believes that queueing theory
is not as useful as some of the other techniques presented in the book.
But the presentation of queueing leaves out some useful techniques.
In particular, M/G/1 systems, which are fairly congenial to solution,
are not presented in detail.
The section also neglects Little's Law in Distribution,
which eases the solution to many common types of queueing models [1,2].
.LP
Taken overall, the book is very impressive.  The survey is can be fairly
called comprehensive, and the depth of discussion is generally appropriate
for a survey.  The text is usually a pleasure to read, a surprise for
a highly mathematical book.  Furthermore, the frequent use of case
studies was effective and sometimes entertaining.  (Indeed, I thought the
case studies alone made interesting reading).
.SH
References
.LP
[1] Keilson J. and L. D. Servi, ``A Distributional Form of Little's Law,''
Operations Research Letters, Vol. 7, No. 5, 1988, pp. 223-227

[2] Keilson J. and L. D. Servi, ``The Distributional Form of Little's Law
and the Fuhrmann-Cooper Decomposition,'' Operations Research Letters, Vol. 9, 
No. 4, 1990, pp. 239-247.
