.nr PO 1.25i
.po 1.25i
.DS C
Review of 
.sp 0.5
John D. Spragins, with Joseph L. Hammond and Krzysztof Pawlikowski,
\fPTelecommunications: Protocols and Design\fP
Addison-Wesley, 1991
.sp 0.5
by Victor T. Norman, Purdue University
.DE
.LP
John D. Spragins' work ventures to cover many of the current protocols,
knowledge, and experience in the telecommunications field.  Spragins' goal
was to write a book that would serve as not only a textbook on
telecommunications, but also as a reference source.  Writing for students
in EE, CE, and CS, Spragins outlines a number of one or two semester
curriculums, each having a different emphasis.  Spragins' approach in this
work is to describe a networking problem and offer solutions as defined by
currently implemented protocols.  The organization of the book centers
around the lower layers of the OSI Reference Model, with a chapter devoted
to each layer from the physical layer up through the transport layer.
Other chapters introduce networking topics and discuss telecommunications
concepts, such as routing, synchronization, flow control, and
internetworking.
.LP
Spragins fails to meet his goal in this work.  This book is neither a
complete reference source, nor a well-written textbook.  As a reference,
the book excels in the number of lower-layer protocols covered, but still
lacks some details that one would expect to find.  For example, the work
mentions very little about addresses and addressing issues -- important
topics in networking.  Thus, there is no mention of Ethernet (IEEE 802.3)
addresses and their format.  Of course, the book cannot be expected to
contain all the information found in all the standards documents, but as a
reference one would expect the work to be more complete.
.LP
As a textbook, Spragins' work falls short.  The book is strong on facts,
but weak on concepts.  The author covers many details of protocol
specifications, but does not introduce a protocol by stating the important
concepts and goals of the protocol.  Also, much of the actual text of the
book is not well-written, containing many sentences that are awkward and
require multiple readings.  Additionally, many computer science students
will find it difficult to comprehend the detailed hardware descriptions.
.LP
Perhaps the most disconcerting feeling one gets when reading this book is
the impression that Spragins did not write this book from his own,
first-hand experiences, but rather from reading standards documents and
other's explanations of protocols and concepts.  One sees this in the
number of illustrations ``adapted'' from other sources, and, occasional
technical inaccuracies reinforce this impression.  For example, Spragins
introduces the interaction between OSI layers and the network by giving an
exchange in which a connection-oriented service at all layers is desired
between two applications on different machines.  The explanation of the
connection set-up for this scenario leads the reader to understand that 14
network packet exchanges are required to accomplish the task (2 for each
OSI layer), which is not correct.
.LP
The organization of this book is poor.  By using the OSI Reference Model,
the book tends to repeat topics, just as the model itself tends to
duplicate concepts at multiple layers.  Topics that do not fit the OSI
Reference Model are thrust somewhat haphazardly into other chapters.  For
instance, the discussion of the IP layer of the TCP/IP Protocol Suite is a
subsection located in the section titled ``Routers and Gateways,'' in the
chapter on ``Internetworking.''
.LP
In summary, Spragins has produced a work that is strong in its emphasis of
lower layers in networking and comes at the telecommunications field from
an electrical engineering point-of-view.  But, this work does not fulfill
the goals set by Spragins himself, in that the book is neither a complete
reference, nor a well-written textbook.
